/* this file contains implementation of the class Heap */
#ifndef HEAP_H
#define HEAP_H

class HeapEntry;
class Heap;
class Disk;

class HeapEntry
{
public:
	int bitcharlen;
	int level;
	int son;
	int ed;
	float key;
	unsigned char *bitchars;

	//-----functions-----
	HeapEntry();
	~HeapEntry();
	void init_HeapEntry(int _bitcharlen);
	void copy(HeapEntry *_he);
};

class Heap
{
private: 
	void enter(HeapEntry *_he, int _pos);
public:
	int bitcharlen;
	int hsize;        // the heap size
	int used;         // number of used places
	HeapEntry *cont;  // content of the heap

	//-----functions-----
	Heap();
	~Heap();
	void Heap::init(int _hsize, int _bitcharlen);
	void insert(HeapEntry *_he);
	bool remove(HeapEntry *_he);
};

#endif